#
# spec file for package gobject-introspection
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#



Name:           gobject-introspection
Version:        0.10.1
Release:        7.5
# FIXME: when bgo#629930 gets fixed, move the appropriate pkg-config files to the main package and rename the devel package to libgirepository-devel
License:        LGPLv2.1+
Summary:        GObject Introspection Tools
Url:            http://live.gnome.org/GObjectIntrospection
Group:          Development/Libraries/GNOME
Source0:        %{name}-%{version}.tar.bz2
Source1:        %{name}-rpmlintrc
BuildRequires:  bison
BuildRequires:  fdupes
BuildRequires:  flex
BuildRequires:  libffi-devel
BuildRequires:  python-devel
BuildRequires:  python-xml
BuildRequires:  cairo-devel
BuildRequires:  glib2-devel
Requires:       gir-repository = %{version}
Requires:       python-xml
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
The goal of the project is to describe the APIs and collect them in
a uniform, machine readable format.

%package -n gir-repository
License:        LGPLv2.1+
Summary:        GObject Introspection Library
Group:          Development/Libraries/GNOME

%description -n gir-repository
The goal of the project is to describe the APIs and collect them in
a uniform, machine readable format.

%package devel
License:        LGPLv2.1+
Summary:        GObject Introspection Development Files
Group:          Development/Libraries/GNOME
# Note: the devel package requires the binaries, not just the library
Requires:       %{name} = %{version}
Requires:       libffi-devel

%description devel
The goal of the project is to describe the APIs and collect them in
a uniform, machine readable format.

%prep
%setup -q

%build
%configure \
        --disable-static
%__make %{?jobs:-j%jobs}

%install
%makeinstall
find %{buildroot} -type f -name "*.la" -delete -print
%fdupes %{buildroot}

%clean
rm -rf %{buildroot}

%post -n gir-repository -p /sbin/ldconfig

%postun -n gir-repository -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc AUTHORS CONTRIBUTORS COPYING COPYING.GPL NEWS README TODO
%{_bindir}/g-ir-annotation-tool
%{_bindir}/g-ir-compiler
%{_bindir}/g-ir-generate
%{_bindir}/g-ir-scanner
%doc %{_mandir}/man1/g-ir-compiler.1*
%doc %{_mandir}/man1/g-ir-generate.1*
%doc %{_mandir}/man1/g-ir-scanner.1*
%{_datadir}/aclocal/introspection.m4
%{_datadir}/gir-1.0/*.gir
# We don't include directly %%{_libdir}/gobject-introspection since there might
# be files there in the future that belong to the library package
%dir %{_libdir}/gobject-introspection
%{_libdir}/gobject-introspection/giscanner/
# We explicitly list the content of the directory that is of interest to us,
# since there might be files there in the future that belong to the library
# package
%dir %{_datadir}/gobject-introspection-1.0
%{_datadir}/gobject-introspection-1.0/Makefile.introspection
%{_datadir}/gobject-introspection-1.0/tests/
%{_datadir}/gobject-introspection-1.0/gdump.c

%files -n gir-repository
%defattr(-,root,root)
%doc COPYING.LGPL
# We own this directory here instead of devel to make sure other packages do
# not have to own it
%dir %{_datadir}/gir-1.0
%{_libdir}/libgirepository-1.0.so.*
%{_libdir}/girepository-1.0/

%files devel
%defattr(-,root,root)
%doc %{_datadir}/gtk-doc/html/gi/
%{_includedir}/gobject-introspection-1.0/
%{_libdir}/libgirepository-1.0.so
# FIXME: those two files should be moved to the main package when bgo#629930 gets fixed
%{_libdir}/pkgconfig/gobject-introspection-1.0.pc
%{_libdir}/pkgconfig/gobject-introspection-no-export-1.0.pc

%changelog
* Fri Jan 14 2011 vuntz@opensuse.org
- Update to version 0.10.1:
  + Scanner:
  - Properly parse recursive list type nodes
  - Fix handling of property transfer
  - Make sure that vfuncs made to the GIR
  + Add API to call the native implementation of a virtual function
  + Update introspection data for gobject/gio.
- Drop gobject-introspection-git-fixes.patch: fixed upstream.
* Sat Jan  8 2011 vuntz@opensuse.org
- Add gobject-introspection-git-fixes.patch: this patch contains
  various commits from git, to fix the build with glib 2.27.90.
* Wed Dec 22 2010 dimstar@opensuse.org
- Update to version 0.10.0:
  + An hash-table index has been added to the typelib format.
    Using a perfect hash generated with the CMPH library allows
    for much more efficient lookups in cases where symbols
    need to be looked up repeatedly.
  + GIO annotations are now extracted from the GLib sources
    (as a manual step; the extracted annotations are shipped
    with gobject-introspection.) This will be extended in
    the future to cover the rest of GLib.
  + UTF-8 string constants are now supported.
  + The cairo typelib now integrates properly with the
    cairo-gobject library.
- Drop patches that were fixed upstream:
  + gobject-introspection-keyring-workaround.patch
  + gobject-introspection-libgda-workaround.patch
* Wed Oct 27 2010 vuntz@opensuse.org
- Add a rpmlintrc file: the devel-file-in-non-devel-package errors
  for gir and source files are wrong here, because
  gobject-introspection is, by definition, a devel package (in the
  same way as gcc is).
- Add an extra %% to a macro in a comment to make rpmlint happy (and
  to make sure that the macro won't get expanded).
* Sat Oct  9 2010 vuntz@opensuse.org
- Update to version 0.9.12:
  + Ship gtk-doc files in tarball.
- Changes from version 0.9.11:
  + Scanner:
  - Add -export-dynamic when compiling with libtool.
  - Honor -L commandline option.
  + Various scanner fixes and improvements.
- Drop gobject-introspection-export-dynamic.patch: fixed upstream.
- Remove comments about upstream tarball and gtk-doc, and remove
  gtk-doc BuildRequires: the files are in the tarball now.
* Fri Oct  1 2010 vuntz@opensuse.org
- Add gobject-introspection-export-dynamic.patch: this fixes the
  build of some gir, like in clutter.
* Fri Oct  1 2010 vuntz@opensuse.org
- Update to version 0.9.10:
  + gir: Explicitly specify path to girepository so libtool can
    find it
- Changes from version 0.9.9:
  + Actually do something about fundamentals when parsing a .gir
  + Abort if we would be generating an empty namespace
  + Minor fixes
* Wed Sep 29 2010 vuntz@opensuse.org
- Update to version 0.9.8:
  + Fix --include-uninstalled
  + Don't ignore annotations if there's a : in docs
- Remove --enable-gtk-doc from configure: API docs got forgotten
  again :/
* Tue Sep 28 2010 vuntz@opensuse.org
- Update to version 0.9.7:
  + Add an annotation tool.
  + Improve gobject/gio annotations.
  + Validate annotations during the scan.
  + Catch cpp errors during the scan.
  + Make Full the default transfer for returned foreign structs.
  + Various scanner fixes and improvements.
- Pass --enable-gtk-doc to configure again, to get API docs.
* Sat Sep 18 2010 vuntz@opensuse.org
- Add gobject-introspection-libgda-workaround.patch: this is a
  workaround needed when generating the gir file for libgda. See
  bgo#629779.
* Fri Sep 17 2010 vuntz@opensuse.org
- Drop gir-repository Recommends from libgirepository-1_0-1: there
  is no real interesting file there anymore.
- Temporarily remove --enable-gtk-doc option from configure: the
  0.9.6 tarball is missing all the files needed for this. See
  bgo#629871.
- Move all gir files to the main package (as well as the m4 file
  and the Makefile), but still keep the /usr/share/gir-1.0
  directory in libgirepository-1_0-1, to not force everybody to own
  it. The reason for the move is that the gobject-introspection
  package is more or less like a compiler, while the devel package
  is really the devel package for the libgirepository-1.0 library.
- However, we need to keep the pkg-config file in the devel
  subpackage at the moment, since they cover both the library and
  the gobject-introspection tools. We'll be able to change this
  when bgo#629930 gets fixed.
- Move the AUTHORS, NEWS and similar files to the main package.
- Add gobject-introspection-keyring-workaround.patch: this is a
  workaround needed when generating the gir file for
  libgnome-keyring. See bgo#629426.
* Thu Sep 16 2010 dimstar@opensuse.org
- Update to version 0.9.6:
  + Fix regressions in the scanner rewrite from 0.9.5, especially
    issues that stopped other modules from building correctly.
  + Various other small improvements and code cleanups in the
    scanner.
  + Add missing annotations to GLib and Gio.
  + Various bug fixes.
* Sat Sep 11 2010 dimstar@opensuse.org
- Update to version 0.9.5:
  + Major rewrite, that leads to a bump in the gir format (version
    1.2).
  + Rename Everything to Regress, and do no longer install it by
    default; instead, ship the C files in
    $(datadir)/gobject-introspection/tests/
  + Fix giscanner crash with no cache directory.
  + Make the scanner parse C++ files too.
  + If GI_SCANNER_DEBUG is set, drop into a debugger on error in
    the scanner.
  + Import DBus, DBusGLib gir from gir-repository.
  + Update some gir files shipped with gobject-introspection.
  + Various bug fixes.
* Fri Aug  6 2010 vuntz@opensuse.org
- Pass --enable-gtk-doc to configure.
* Thu Aug  5 2010 lmedinas@opensuse.org
- Update to version 0.9.3:
  + Add annotations for g_variant_new_strv() and
    g_variant_get_strv()
  + Add annotation for g_dbus_proxy_new_sync
  + Fix ordering in override_search_path on gir-repository
  + Make scanner compatible with python 2.y
  + Add g_irepository_enumerate
  + Append -Wl,-rpath=. to the scanner compile
  + Add g_info_type_to_string (GIInfoType type)
  + Add new API g_typelib_require_private()
  + Misc bug fixes
- Add gtk-doc to BuildRequires
* Wed Jul 21 2010 vuntz@opensuse.org
- Clean up update to 0.9.2.
- Change cairo-devel, glib2-devel BuildRequires to pkgconfig(cairo)
  and pkgconfig(gobject-2.0).
- Remove checks for old versions of openSUSE (<= 11.1).
- Remove glib2-devel Requires of devel package: it's now
  automatically handled with pkgconfig() Requires.
- Fix post/postun to be for libgirepository-1_0-1.
* Thu Jul 15 2010 dimstar@opensuse.org
- Upate to version 0.9.2:
  + Add some cairo methods
  + Add support for non-GObject fundamental objects
  + Bump shared library version, typelib version
  + Don't include machine-dependent integral types in the typelib
  + Bug fixes
- Rename libgirepository-1_0-0 to libgirepository-1_0-1
* Mon Jul  5 2010 dimstar@opensuse.org
- Update to version 0.9.0:
  + Barf if running on unsupported platform
  + Annotate GVariant as a foreign struct
  + Support the (transfer) annotation for properties
  + Allow for methods in GLib
  + Add versioning to the cache
  + Add some more Gio annotations
  + Apply annotations from invoker to vfunc
  + Support introspectable=no attribute, add warnings framework
  + Allow attributes on parameters and return values
  + Clean up annotation parsing, don't try to parse invalid
    annotations
  + Cleanups and code reorganization
  + Bug fixes
  + Update docs
- Changes from version 0.6.14:
  + Support unsigned long/short int
  + Add type annotation for properties
  + Fix marshalling of GStrv
  + Bug fixes
  + Update docs
* Fri May 28 2010 dimstar@opensuse.org
- Update to version 0.6.12:
  + Build system cleanups
  + Documentation updates
  + Minor bugfixes
- Changes from version 0.6.11:
  + Add various annotations
  + Take into account the underscore after the type name when
    checking if a function is a method
  + Use g_slice
  + Add support for the 'foreign' annotation to g-i-scanner
  + Bug fixes
  + Update docs
- Changes from version 0.6.10:
  + Add GKeyFile annotations
  + Revert a change that makes gjs crash
  + Correctly use ffi_closure_alloc(), fixing mmap permissions
    error
  + Assert input values in Everything funcs
  + Add GIMarshallingTests typelib
  + If needed, convert from camelcase to underscores when stripping
    the prefix of constants
  + Add foreign struct funcs to Everything
  + Add a simple callback type which has no arguments or return
    values
  + Make g_file_set_contents() take uint8*, not utf8
  + Warn about annotations for unknown args
  + Add support for GArrays
  + Use -1 not None for closure/destroy indices
  + Validate scope annotation values and parameter references
  + Add a basic gir for xrandr
  + Add uid_t, gid_t, dev_t to integral type conversions
  + Add tests
  + Update docs
  + Minor bug fixes
- BuildRequire cairo-devel
* Fri Mar 19 2010 dimstar@opensuse.org
- Update to version 0.6.9:
  + Correctly cast to a CommonBlob when looking up embedded types
  + g-ir-compiler: Slightly less lame error messages
  + [everything] Add some "torture" test functions with baroque
    signatures
  + scanner: Catch OSError too when checking for libtool
  + scanner: Always explicitely set the scope of callbacks
* Wed Mar 10 2010 dimstar@opensuse.org
- Update to version 0.6.8:
  + [girffi] Clean up API, add g_function_info_prep_invoker
  + Allow stack allocating GIBaseInfo, add stack retrieval variants
  + scanner: Always explicitely set the scope of callbacks
  + scanner: Print error instead of throwing for unknown include
* Thu Dec 17 2009 vuntz@opensuse.org
- Update to version 0.6.7:
  + Add a Makefile.introspection file.
  + Revert "GI_TYPE_TAG_VOID != ffi_type_void"
  + protect on null retval
  + fix invoke tests
  + Substitute deprecated Glib symbol: g_mapped_file_free
* Wed Dec 16 2009 vuntz@opensuse.org
- Add libffi-devel Requires to devel package; this fixes the build
  of packages linking to gobject-introspection.
* Mon Dec 14 2009 dimstar@opensuse.org
- Update to version 0.6.6:
  + Make g-ir-scanner 64-bit enable. bgo#593639
  + Consistently resolve symbolic links
  + Improve warning and error messages.
  + Explicitly sort object interfaces, properties, and signals
  + When doing type resolution on a string, treat it as its own
    ctype
  + Implement callbacks as part of struct fields. bgo#557383
  + Add g_ir_ffi_convert_arguments
  + Add a method to compare infos
  + Make (skip) annotation work everywhere
  + InitiallyUnownedClass should contain all the fields as
    ObjectClass
  + Ignore errors caused by permissions in $HOME
  + Add async callback tests to everything
  + [dumper] Fix threads initialization
  + Allow NULL to be sent in for various callbacks
  + Fix an annotationparser bug for empty tags
  + Add/Fix annotations.
  + Many small bug fixes.
  + Build fixes.
  + Build system fixes.
* Wed Sep  9 2009 vuntz@opensuse.org
- Update to version 0.6.5:
  + Replace LIBTOOL_LIBTOOL to LIBTOOL (bgo#592968)
  + Use CC rather than LD to fix build issue for gir (bgo#593599)
  + Add GVolumeMonitor interfaces
  + Use built scanner from tarball builds (bgo#593162)
  + Fix unref of GIUnresolvedInfo instances (bgo#593322)
  + Add CLFAGS and LIBS variables
  + Correctly ref repository in GIUnresolvedInfo
* Tue Aug 25 2009 vuntz@novell.com
- Update to version 0.6.4:
  + Add annotations for various API, update for some API.
  + Bug fixes.
  + Add COPYING.GPL and COPYING.LGPL.
- Add Requires on python-xml.
* Tue Jun 23 2009 dominique-obs@leuenberger.net
- Update to version 0.6.3:
  + Too many bugfixes to mention, see NEWS for full details
- Remove gobject-introspection-git-20090501.patch.bz2 and it's
  requirements. The tarball is newer than the used git-patch
* Mon May  4 2009 vuntz@novell.com
- Fix build on 11.1.
* Fri May  1 2009 vuntz@novell.com
- Make libgirepository-1_0-0 Recommends gir-repository.
* Fri May  1 2009 vuntz@novell.com
- Move package doc files to libgirepository-1_0-0 since this is the
  important package.
* Fri May  1 2009 vuntz@novell.com
- Initial package.
